from dosi.utils import *

class Wu_SPI(object):
    def __init__(self, device):
        self.dev = device

#    def enable(self, ch_i):
#        if ch_i in range(1,7): # DDS Channel Numbers from 1 to 6
#            self.dev.getNode("DDS{0}Output".format(ch_i)).write(1<<22)
#            self.dev.dispatch()
#        else:
#            raise

#    def disable(self, ch_i):
#        if ch_i in range(1,7): # DDS Channel Numbers from 1 to 6
#            self.dev.getNode("DDS{0}Output".format(ch_i)).write(0)
#            self.dev.dispatch()
#        else:
#            raise

    def doCmd(self, len):
        self.dev.getNode("SPI_CMD").write(len)
        z = self.dev.getNode("SPI_STATUS").read()
        self.dev.dispatch()
        while (int(z) & 0x8):
            z = self.dev.getNode("SPI_STATUS").read()
            self.dev.dispatch()
            print "BUSY"

    def send(self, msg, rlen=0):
        total_len = len(msg) - 1 + rlen
        message = []
        for word32 in grouper(4, msg,0):
            message.append(bytes2int32(word32))
        self.dev.getNode("SPI_WBUF").writeBlock(message)
        self.dev.dispatch()

        self.doCmd(total_len)
        if rlen > 0:
            return 0
        else:
            return 0
