from itertools import izip_longest

def grouper(n, iterable, fillvalue=None):
    "grouper(3, 'ABCDEFG', 'x') --> ABC DEF Gxx"
    args = [iter(iterable)] * n
    return izip_longest(fillvalue=fillvalue, *args)

def bytes2int32(bytes): # assume 0 is MSB
    res = 0
    if len(bytes) == 4:
        res = ((bytes[0] & 0xff)<<24) | ((bytes[1] & 0xff) << 16) | ((bytes[2] &0xff)<<8) | (bytes[3] & 0xff)
    return res


def calculateFTW(f_out, f_sysclk=1e9):
    return (2**32) * ( (f_out/f_sysclk))

def argStringToFTW(args_str):
    clean_string = args_str.strip()
    args = clean_string.split()
    i = 0
    multiplier = 1
    if (len(args) == 1):
        args[1] = 'x'
        
    if (len(args) == 2):
        if (args[1] == 'x'):
            i = int(args[0], 16)
        elif (args[1] == 'i'):
            i = int(args[0])
        elif (args[1][1:] == 'Hz') or (args[1][1:] == 'hz') or (args[1][1:] == 'HZ') or args[1] == 'Hz' or args[1] == 'hz':
            if args[1][0] == 'k': # kHz
                multiplier = 10**3
            elif args[1][0] == 'M': # MHz
                multiplier = 10**6
            elif len(args[1][0]) == 2:
                multiplier = 1
            else: 
                raise
            i = int(calculateFTW(multiplier* float(args[0])))
    return i
